%%%%%%%%%%%%%%%%%%%%% Start of the program for the measurement of %%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% Instantaneous velocity and average velocity %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% By Lokesh Agrawal %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% Supervised by Prof. Marco Terenzio %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% Date: Aug 26th, 2020 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% Okinawa Institute of Science and Technologies%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% Japan %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clc;
clear all;
close all;
Vescicle = imread('Kymograph2.jpg');
Vescicle_BW = im2bw(Vescicle,0.5);
img=Vescicle_BW;
figure,
imshow(Vescicle_BW,'InitialMagnification',2000);
[Yp,Xp]=size(Vescicle_BW);
impixelinfo;
hold on;
axis on;
axis image;
grid on;

% input from the user.
%x_dist_factor=input("please enter pixelwise distance factor for x axis in micro-meters: ");
%y_time_factor=input("please enter pixelwise time step for y axis in milli-sec or sec: ");
disp("User please click at the start point and end point to select a line  : ");
coordinates_input1= ginput(2);

x1 = coordinates_input1(1,1);
y1 = coordinates_input1(1,2);
x2 = coordinates_input1(2,1);
y2 = coordinates_input1(2,2);


% calculation of the pixels from start point to end point of the line

numSamples = ceil(sqrt((x2-x1)^2+(y2-y1)^2) / 0.4);
x = linspace(x1, x2, numSamples);
y = linspace(y1, y2, numSamples);

%remove the duplicate pixels
xy = round([x',y']);
dxy = abs(diff(xy, 1));
duplicateRows = [0; sum(dxy, 2) == 0];
finalxy = xy(~duplicateRows,:);
finalx = finalxy(:, 1);
finaly = finalxy(:, 2);

% Plot the points
plot(finalx, finaly, '-r');
disp(finalxy);

%Loop for the nearest point of the pixels neighbour hood algorithm
[r,c]=size(finalxy);
pArray=[];

for i=1:i+1:r
    
   Px=finalxy(i,1);
   Py=finalxy(i,2);
  % dist=[];
  % Array=[];
   %loop on binary image to find the enarest white point
   k=0;
   j=0;
   s1=Py;
   e1=Py;
   %window=input("Please enter window to search pixel in x axis using Neighnourhood algo");
   window=4;
   s=Px-window; %window to search pixel in x axis Neighnourhood algo
   e=Px+window; % window to search pixel in x axis Neighnourhood algo
   
   for j=s1 %loop for y
       
       for k=s:k+1:e %loop for x
           
           b=[k,j];
           
          if ((img(j,k)>0) && isempty(pArray))
              
                pArray=[pArray;k,j];
                  
          elseif((img(j,k)>0) & (~ismember(b,pArray,'rows')))
                    
                    pArray=[pArray;k,j];
            
          else
                      pArray;
          end
           
       end
       
   end
      
end

disp("pArray: ");
disp(pArray);

%%% finding the index of repeated values function calling 1
[index] = index_repeated_element(pArray);

%%%% selection of first x element index(:,3)==1

Rw_of_initial_x_points=find(index(:,3)==1);

Array_for_distance=[];

for i=1:length(Rw_of_initial_x_points)
    indexval=Rw_of_initial_x_points(i);
    Array_for_distance = [Array_for_distance;pArray(indexval,:)];
end

disp(Array_for_distance);

%Calculation of spontaneous velocity.............
x_dist_factor=1.2068; %input by user 
y_time_factor=5; %input by user
cal_spontaneous_vel=vel(Array_for_distance,x_dist_factor,y_time_factor); %function_calling
disp(cal_spontaneous_vel);
[m,n]=size(cal_spontaneous_vel);

%%%%%%%%%Average Vel%%%%%%%%%%%%%%%%%
Average_vel=(sum(cal_spontaneous_vel(:,n)))/m;
disp("Avergae_vel:: ");
disp(Average_vel);

%%%%saving data in folder in the form of CSV file

%%%folder creation
foldername='C:\Instantaneous_vel\';
if ~exist(foldername,'dir')
        mkdir(foldername);
end

%write CsV
filename = 'C:\Instantaneous_vel\Cordinate_file_with_vel.csv' ;
%%%calling function
Save_data_in_CSV(cal_spontaneous_vel,filename);
%csvwrite(filename,cal_spontaneous_vel);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%End of the program %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

